> ## Documentation Index
> Fetch the complete documentation index at: https://developers.criteo.com/llms.txt
> Use this file to discover all available pages before exploring further.

# /preview/retail-media/line-items/{line-item-id}/products/append

> Append a collection of promoted products to a line item



## OpenAPI

````yaml https://api.criteo.com/preview/retailmedia/open-api-specifications.json post /preview/retail-media/line-items/{line-item-id}/products/append
openapi: 3.0.1
info:
  title: Criteo API
  description: Criteo API - RetailMedia
  version: Preview
servers:
  - url: https://api.criteo.com
security:
  - oauth: []
tags:
  - name: Accounts
  - name: Analytics
  - name: Audience
  - name: Balance
  - name: Campaign
  - name: Catalog
  - name: Gateway
  - name: OnSiteRecommendation
  - name: ThirdPartyAccounts
paths:
  /preview/retail-media/line-items/{line-item-id}/products/append:
    post:
      tags:
        - Campaign
      summary: /preview/retail-media/line-items/{line-item-id}/products/append
      description: Append a collection of promoted products to a line item
      operationId: AppendPromotedProducts
      parameters:
        - name: line-item-id
          in: path
          description: ID of the line item
          required: true
          schema:
            type: string
      requestBody:
        description: Request body whose {data} contains an array of promoted products.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PromotedProductResourceCollectionInput'
      responses:
        '200':
          description: Promoted products appended to the line item with warnings
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProductResourceOutcome'
        '204':
          description: Promoted products appended to the line item
      security:
        - oauth:
            - RetailMedia_Campaign_Manage
components:
  schemas:
    PromotedProductResourceCollectionInput:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/PromotedProductResource'
      additionalProperties: false
      description: >-
        Request object containing promoted products to be appended, deleted,
        paused or unpaused.
    ProductResourceOutcome:
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: '#/components/schemas/RmcaCommonProblem'
          nullable: true
        warnings:
          type: array
          items:
            $ref: '#/components/schemas/RmcaCommonProblem'
          nullable: true
      additionalProperties: false
      description: Outcome object containing errors and warnings.
    PromotedProductResource:
      type: object
      properties:
        attributes:
          $ref: '#/components/schemas/PromotedProduct'
        id:
          type: string
          nullable: true
        type:
          type: string
          nullable: true
      additionalProperties: false
      description: Resource object containing a promoted product.
    RmcaCommonProblem:
      type: object
      properties:
        code:
          type: string
          description: A machine-readable  error code, expressed as a string value.
          nullable: true
        detail:
          type: string
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem
          nullable: true
        instance:
          type: string
          description: A URI that identifies the specific occurrence of the problem.
          nullable: true
        source:
          type: object
          additionalProperties:
            type: string
          description: >-
            A machine-readable structure to reference to the exact location(s)
            causing the error(s)
          nullable: true
        stackTrace:
          type: string
          nullable: true
        status:
          type: integer
          description: The problem's HTTP Status code.
          format: int32
          nullable: true
        title:
          type: string
          description: A short human-readable description of the problem type
          nullable: true
        traceId:
          type: string
          description: The request correlation ID this problem comes from.
          nullable: true
        type:
          enum:
            - unknown
            - access-control
            - authentication
            - authorization
            - availability
            - deprecation
            - quota
            - validation
          type: string
          description: The problem's category.
          nullable: true
      additionalProperties: {}
      description: Common problem object.
    PromotedProduct:
      type: object
      properties:
        bidOverride:
          type: number
          description: >-
            The bid override for the promoted product for this line item.
            Ignored unless adding a product.
          format: decimal
          nullable: true
        id:
          type: string
          description: A retailer defined SKU ID for the promoted product.
          nullable: true
        status:
          $ref: '#/components/schemas/LineItemProductStatus'
      additionalProperties: false
      description: A promoted product.
      nullable: true
    LineItemProductStatus:
      enum:
        - unknown
        - active
        - paused
      type: string
      description: The status of a promoted product in the context of the line item.
      nullable: true
  securitySchemes:
    oauth:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: https://api.criteo.com/oauth2/token
          scopes: {}
        authorizationCode:
          authorizationUrl: https://api.criteo.com/oauth2
          tokenUrl: https://api.criteo.com/oauth2/token
          scopes: {}

````